/*
 * This file is a part of the CaosDB Project.
 *
 * Copyright (C) 2025 IndiScale GmbH <info@indiscale.com>
 * Copyright (C) 2025 Joscha Schmiedt <joscha@schmiedt.dev>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <https://www.gnu.org/licenses/>.
 */

package org.caosdb.server.grpc;

import static org.junit.jupiter.api.Assertions.assertEquals;

import static org.junit.jupiter.api.Assertions.assertTrue;

import org.caosdb.api.scripting.v1alpha1.ExecuteServerSideScriptRequest;
import org.caosdb.api.scripting.v1alpha1.NamedArgument;
// Python Test Case
// response = run_server_side_script("my_script.py",
//                                   "pos0",
//                                   "pos1",
//                                   option1="val1",
//                                   option2="val2",
//                                   files={"-Ofile": "test_file.txt"})
// assert response.stderr is None
// assert response.code == 0
// assert response.call == ('my_script.py '
//                          '--option1=val1 --option2=val2 --file=.upload_files/test_file.txt '
//                          'pos0 pos1')
import org.junit.jupiter.api.Test;

public class ServerSideScriptingGrpcTest {
  @Test
  public void testExecuteServerSideScriptRequestToCommandline() {
    ExecuteServerSideScriptRequest request = ExecuteServerSideScriptRequest.newBuilder()
        .setScriptFilename("my_script.py")
        .addPositionalArguments("pos0")
        .addPositionalArguments("pos1")
        .addNamedArguments(NamedArgument.newBuilder().setName("option1").setValue("val1").build())
        .addNamedArguments(NamedArgument.newBuilder().setName("option2").setValue("val2").build())
        // .putFiles("-Ofile", "test_file.txt")
        .build();

    ArrayList<String> commandline = ServerSideScriptingServiceImpl.request2CommandLine(request);
    // assertEquals(commandline,
        // "my_script.py --option1=val1 --option2=val2 --file=.upload_files/test_file.txt pos0 pos1");
  // }
}
